//package nl.kallestruik.dtweaks.commands
//
//import co.aikar.commands.BaseCommand
//import co.aikar.commands.annotation.*
//import co.aikar.commands.annotation.Optional
//import com.mojang.datafixers.util.Pair
//import it.unimi.dsi.fastutil.objects.Object2IntMap
//import net.kyori.adventure.text.Component
//import net.kyori.adventure.text.format.TextColor
//import net.minecraft.server.v1_16_R3.ChunkMapDistance
//import net.minecraft.server.v1_16_R3.EnumCreatureType
//import nl.kallestruik.dlib.ReflectionUtil
//import org.bukkit.Bukkit
//import org.bukkit.command.CommandSender
//import org.bukkit.craftbukkit.v1_18_R1.CraftWorld
//import org.bukkit.entity.Player
//import java.util.*
//
//@CommandAlias("mobcaps")
//class CommandMobcaps(
//    private val reflectionUtil: ReflectionUtil
//): BaseCommand() {
//
//    @Default
//    @Subcommand("view")
//    @CommandCompletion("@worlds")
//    fun onMobcaps(sender: CommandSender, @Optional worldName: String?) {
//        var craftWorld: CraftWorld? = null
//
//        if (sender is Player)
//            craftWorld = (sender.world as CraftWorld)
//        else if (worldName == null)
//            sender.sendMessage(Component.text("ERROR: You need to be a player or supply a world name!").color(TextColor.color(0x660000)))
//        var name = worldName
//        if (worldName == null) {
//            name = craftWorld?.name
//        } else {
//            val bukkitWorld = Bukkit.getWorld(worldName)
//            if (bukkitWorld == null)
//                name = craftWorld?.name
//            else
//                craftWorld = (bukkitWorld as CraftWorld)
//        }
//
//        val world = craftWorld?.handle ?: return
//
//        val chunkMapDistance = (
//                reflectionUtil.getValueFromField(world.getChunkProvider(), "chunkMapDistance")
//                    ?: return
//                ) as ChunkMapDistance
//
//        val chunks = chunkMapDistance.b()
//
//        // world.getChunkManager().getSpawnInfo();
//        val spawnInfo = world.getChunkProvider()?.k() ?: return
//
//        val mobs: Object2IntMap<EnumCreatureType> = spawnInfo.b()
//        val mobcaps = EnumMap<EnumCreatureType, Pair<Int, Int>>(
//            EnumCreatureType::class.java
//        )
//        for (category in EnumCreatureType.values()) {
//            if (category == EnumCreatureType.MISC) continue
//            val cur: Int = mobs[category]?: 0
//            val max = chunks * category.c() / (17 * 17)
//            mobcaps[category] = Pair(cur, max)
//        }
//
//        sender.sendMessage("=============Mobcaps [${name}]=============")
//        for ((key, value) in mobcaps) {
//            val cur = value.first
//            val max = value.second
//            sender.sendMessage("${key.getName()}: ${cur}/${max}")
//        }
//    }
//}